(function () {
    "use strict";

    angular.module('core').controller('saidaController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$state', '$stateParams', 'lookupService', 'saidaService', '$alert'];

    function controller($scope, $timeout, $q, $state, $stateParams, lookupService, saidaService, $alert) {
        $scope.initializeLayout('Saída');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: null,
            }
        };
        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    saidaService
                        .save({ item: $scope.popups.add.data })
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $state.go("state-saida-edit", { id: response.Data.ID });
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                prepare: function () {
                    saidaService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $timeout(function () { $('[ng-model*="popups.add.data.Fornecedor"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.popups.edit.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 1,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                }
            }
        };
        $scope.auxiliar = {
            fornecedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFornecedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            empresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            transportadora: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTransportadora({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            tabelaPreco: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTabelaPreco({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            condicaoPagamento: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCondicaoPagamentoAtacado({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            naturezaOperacao: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllNaturezaOperacaoSaida({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            }
        };

        //[Inicializa funcões]
        $scope.initialize = async () => {
            await $scope.clearFilter();

            const _filtro = $scope.localStorage.getItem('state.filtro.args');
            if (_filtro) {
                await angular.copy(_filtro, $scope.state.filtro.args);
            }

            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);

            $scope.refresh();
        };

        $scope.beforeRefresh = async () => {
            await $scope.convertFilter();
        };
        $scope.afterRefresh = async () => {
            /* trata mudanças no filtro */
            $scope.state.filtro.original.sortExpression = $scope.state.filtro.args.sortExpression;
            $scope.state.filtro.original.skip = $scope.state.filtro.args.skip;
            $scope.state.filtro.original.take = $scope.state.filtro.args.take;

            $scope.state.filtro.hasChanges = (angular.toJson($scope.state.filtro.original) !== angular.toJson($scope.state.filtro.args));

            /* armazena na localstorage para quando inicializar a página */
            $scope.localStorage.setItem('state.filtro.args', $scope.state.filtro.args);
        };
        $scope.refresh = async () => {
            try {
                await $scope.beforeRefresh();
                $scope.state.filtro.ativo = false;
                await $scope.innerRefresh();
                await $scope.afterRefresh();
            }
            catch (error) {
                console.error(error);
                $scope.clearFilter();
            } finally {
                $scope.$digest();
            }
        };
        $scope.clear = async () => {
            await $scope.clearFilter();
            $scope.refresh();
        };

        $scope.toggleFilter = async () => {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };
        $scope.convertFilter = async () => {
            /* prepara o filtro. Ex: in list de status */
        };
        $scope.clearFilter = async () => {
            $scope.state.filtro = {
                args: {
                    chaves: '',
                    filtro: null,
                    filtroDe: null,
                    filtroAte: null,
                    filtroEm: null,
                    sortExpression: '[CriadoEm] desc',
                    skip: 0,
                    take: 20,
                },
                original: {},
                hasChanges: false
            };

            await $scope.convertFilter();
            await angular.copy($scope.state.filtro.args, $scope.state.filtro.original);
        };

        $scope.innerRefresh = async () => {
            await $scope.getAll();
            await $scope.count();
        };
        $scope.getAll = async () => {
            try {
                $scope.state.filtro.args.skip = 0;
                $scope.state.carregando = true;
                $scope.state.completo = false;
                $scope.state.vazio = false;

                const response = await saidaService.getAll($scope.state.filtro.args);
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    angular.copy(angular.fromJson(response.Data), $scope.state.data);
                }
                $scope.state.vazio = ($scope.state.data == 0);
            }
            catch (err) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(err)
            }
            finally {
                $scope.state.carregando = false;
            }
        };
        $scope.count = async () => {
            try {
                const response = await saidaService.count($scope.state.filtro.args);

                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.count = response.Data;
                }
            }
            catch (err) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(err)
            } finally {
            }
        };
        $scope.getMore = async () => {
            if (!$scope.state.carregandoMais && !$scope.state.carregando && !$scope.state.completo && !($scope.state.data == 0)) {
                try {
                    $scope.state.carregandoMais = true;
                    $scope.state.filtro.args.skip += $scope.state.filtro.args.take;

                    let response = await saidaService.getAll($scope.state.filtro.args)
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                        $scope.state.completo = (response.Data == 0);
                    }
                } catch (err) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(err);
                } finally {
                    $scope.state.carregandoMais = false;
                    $scope.$digest();
                }
            }
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();